/*
 * Correctly rounded hyperbolic sine and cosine
 *
 * Copyright (C) 2004-2011 David Defour, Catherine Daramy-Loirat,
 * Florent de Dinechin, Matthieu Gallet, Nicolas Gast, Christoph Quirin Lauter,
 * and Jean-Michel Muller
 *
 * This file is part of crlibm, the correctly rounded mathematical library,
 * which has been developed by the Arénaire project at École normale supérieure
 * de Lyon.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 */


 /* File generated by maple/csh.mpl */ 

 static double maxepsilon_csh = 7.691977781471974651029816959786e-19 ;
 static double round_cst_csh  = 1.014076581900344724984466743033e+00 ;

#ifdef WORDS_BIGENDIAN  
  static db_number const inv_ln_2 =     {{0x3FF71547,0x652B82FE}};     /*1.4426950409e+00*/  
  static db_number const ln2_hi =       {{0x3FE62E42,0xFEFA3800}};     /*6.9314718056e-01*/  
  static db_number const ln2_lo =       {{0x3D2EF357,0x93C76730}};     /*5.4979230187e-14*/  
  static db_number const two_43_44 =    {{0x42B80000,0x00000000}};     /*2.6388279067e+13*/  
  static db_number const two_minus_30 = {{0x3D700000,0x00000000}};     /*9.0949470177e-13*/  
  static int const bias = 89 ;

/* some bounds */ 
  static db_number const max_input_csh =  {{0x408633CE,0x8FB9F87E}};     /*7.1047586007e+02*/  

  static const db_number cosh_sinh_table[179][4] = { 
	{{{0x3FF0FA08, 0xD2F35F97}}, {{0x3C9B39D1, 0x9DAB3AF1}},
	  {{0xBFD6B36F, 0xBB84C928}}, {{0xBC68DAF8, 0xFEFE1E5F}}},
	{{{0x3FF0F464, 0x73177841}}, {{0xBC97DF60, 0x29551C51}},
	  {{0xBFD66F92, 0xE6A06FC9}}, {{0x3C70A785, 0xD9A66B42}}},
	{{{0x3FF0EED1, 0x07A16DB4}}, {{0x3C988108, 0xD3E071F5}},
	  {{0xBFD62BCC, 0x8150DBAB}}, {{0xBC7700BD, 0xF95D00CA}}},
	{{{0x3FF0E94E, 0x8AFDD406}}, {{0xBC9330CB, 0xB0B14F49}},
	  {{0xBFD5E81C, 0x47CFA1DB}}, {{0x3C791EC5, 0x4E7B2C63}}},
	{{{0x3FF0E3DC, 0xF7AA2E1B}}, {{0x3C9C05BD, 0xF7FB3140}},
	  {{0xBFD5A481, 0xF66C8331}}, {{0xBC6E8E0C, 0xCFF78DD1}}},
	{{{0x3FF0DE7C, 0x4834E82E}}, {{0xBC877BEC, 0x5F430E44}},
	  {{0xBFD560FD, 0x498D28AA}}, {{0x3C4F07B3, 0xCCEA8A26}}},
	{{{0x3FF0D92C, 0x773D5255}}, {{0xBC84956C, 0x3D5D1DA2}},
	  {{0xBFD51D8D, 0xFDACDFC5}}, {{0x3C419F0E, 0x98966B86}}},
	{{{0x3FF0D3ED, 0x7F739B28}}, {{0xBC99722F, 0xEA8A9ED5}},
	  {{0xBFD4DA33, 0xCF5C5703}}, {{0xBC7B1F07, 0x7BE71FBE}}},
	{{{0x3FF0CEBF, 0x5B98CA6C}}, {{0x3C9E8080, 0x09B9F220}},
	  {{0xBFD496EE, 0x7B415A78}}, {{0x3C51C3BA, 0xBDFE61F1}}},
	{{{0x3FF0C9A2, 0x067EBBDA}}, {{0x3C813CD8, 0x803D61F3}},
	  {{0xBFD453BD, 0xBE16906C}}, {{0xBC78D781, 0x45D8536E}}},
	{{{0x3FF0C495, 0x7B0819E9}}, {{0x3C9A26E0, 0x6E52BA24}},
	  {{0xBFD410A1, 0x54AB361D}}, {{0x3C78DCB6, 0xCF7DA2E8}}},
	{{{0x3FF0BF99, 0xB42858B8}}, {{0xBC67AD83, 0x0B1F30A5}},
	  {{0xBFD3CD98, 0xFBE2DC86}}, {{0x3C7D0A5E, 0x269038FC}}},
	{{{0x3FF0BAAE, 0xACE3B0FC}}, {{0xBC93292F, 0x75521E77}},
	  {{0xBFD38AA4, 0x70B52549}}, {{0x3C67F94B, 0x0B01B8A6}}},
	{{{0x3FF0B5D4, 0x604F1B07}}, {{0x3C732C14, 0x07EECFA5}},
	  {{0xBFD347C3, 0x702D7FA4}}, {{0xBC7435BE, 0x701422C8}}},
	{{{0x3FF0B10A, 0xC99049DE}}, {{0xBC617C2D, 0x610FCC2E}},
	  {{0xBFD304F5, 0xB76AE57E}}, {{0x3C75EB09, 0x42E4CA9C}}},
	{{{0x3FF0AC51, 0xE3DDA65B}}, {{0x3C9B22C0, 0x9DACA977}},
	  {{0xBFD2C23B, 0x039F9881}}, {{0xBC577301, 0x9B082732}}},
	{{{0x3FF0A7A9, 0xAA7E4A68}}, {{0x3C71B296, 0x281520E0}},
	  {{0xBFD27F93, 0x1210DF54}}, {{0x3C6EF999, 0x502A1E59}}},
	{{{0x3FF0A312, 0x18C9FC41}}, {{0x3C885259, 0x09E044C2}},
	  {{0xBFD23CFD, 0xA016C2D9}}, {{0x3C500762, 0x449D986B}}},
	{{{0x3FF09E8B, 0x2A2929D1}}, {{0xBC9EE5F5, 0x535446B4}},
	  {{0xBFD1FA7A, 0x6B1BCB8A}}, {{0xBC50621A, 0x5A4CB636}}},
	{{{0x3FF09A14, 0xDA14E415}}, {{0xBC965668, 0x233B29C8}},
	  {{0xBFD1B809, 0x309CBEE1}}, {{0xBC6E5B16, 0xBBB1CB75}}},
	{{{0x3FF095AF, 0x2416DA9A}}, {{0x3C8024A0, 0x39DC7749}},
	  {{0xBFD175A9, 0xAE285CD6}}, {{0x3C3DB749, 0xC4496E39}}},
	{{{0x3FF0915A, 0x03C95705}}, {{0x3C78A8A6, 0x0BD1CD00}},
	  {{0xBFD1335B, 0xA15F1D6C}}, {{0x3C53CE0F, 0x341ED7B6}}},
	{{{0x3FF08D15, 0x74D738AC}}, {{0xBC984BD5, 0xC4A8C043}},
	  {{0xBFD0F11E, 0xC7F2EE53}}, {{0xBC75BADF, 0xC5355AFC}}},
	{{{0x3FF088E1, 0x72FBF041}}, {{0xBC9DE12F, 0x0D55140F}},
	  {{0xBFD0AEF2, 0xDFA6F09B}}, {{0x3C414E60, 0xA7827088}}},
	{{{0x3FF084BD, 0xFA037B8F}}, {{0xBC7D97E2, 0xE3C5EBFC}},
	  {{0xBFD06CD7, 0xA64F3673}}, {{0xBC6370BA, 0x839871E4}}},
	{{{0x3FF080AB, 0x05CA6146}}, {{0xBC723216, 0xFC66378F}},
	  {{0xBFD02ACC, 0xD9D08102}}, {{0x3C5998B3, 0x20C03715}}},
	{{{0x3FF07CA8, 0x923DACD6}}, {{0xBC9653A7, 0xE736D67A}},
	  {{0xBFCFD1A4, 0x703FFC8F}}, {{0xBC59EA3B, 0xA8860819}}},
	{{{0x3FF078B6, 0x9B5AEA5C}}, {{0xBC8880D6, 0x6B6D819B}},
	  {{0xBFCF4DCE, 0xFE860E28}}, {{0xBC6883D4, 0xC6A2C678}}},
	{{{0x3FF074D5, 0x1D3022A1}}, {{0x3C9E93F8, 0x2426EF93}},
	  {{0xBFCECA18, 0xDA9DBA19}}, {{0x3C36D470, 0x491D8A98}}},
	{{{0x3FF07104, 0x13DBD729}}, {{0x3C766560, 0xCA5328ED}},
	  {{0xBFCE4681, 0x80D0D17F}}, {{0x3C605627, 0x658D0660}}},
	{{{0x3FF06D43, 0x7B8CFE4D}}, {{0xBC73ADF7, 0xD1025E7E}},
	  {{0xBFCDC308, 0x6D87EF96}}, {{0x3C6C0BD9, 0x2A97B34C}}},
	{{{0x3FF06993, 0x5082FF6E}}, {{0x3C7685C4, 0xD7395A9F}},
	  {{0xBFCD3FAD, 0x1D49F620}}, {{0x3C5DE851, 0x26ECE4F0}}},
	{{{0x3FF065F3, 0x8F0DAF34}}, {{0xBC7821B3, 0xAF1520A9}},
	  {{0xBFCCBC6F, 0x0CBB89ED}}, {{0xBC4B40A0, 0x51092884}}},
	{{{0x3FF06264, 0x338D4BDC}}, {{0xBC90000F, 0xF34422A4}},
	  {{0xBFCC394D, 0xB89E8F7F}}, {{0xBC646F77, 0x52292D2D}}},
	{{{0x3FF05EE5, 0x3A727999}}, {{0x3C92512F, 0x6647668D}},
	  {{0xBFCBB648, 0x9DD1A7CC}}, {{0x3C234425, 0x3ED3824D}}},
	{{{0x3FF05B76, 0xA03E3F07}}, {{0x3C7CA615, 0x2B52E765}},
	  {{0xBFCB335F, 0x394FAD1B}}, {{0xBC47F257, 0x34B51ACE}}},
	{{{0x3FF05818, 0x618201A8}}, {{0xBC8BFA98, 0x5A557953}},
	  {{0xBFCAB091, 0x082F3002}}, {{0x3C4B6626, 0x60BF022C}}},
	{{{0x3FF054CA, 0x7ADF8277}}, {{0x3C89C0C1, 0x377A9F8C}},
	  {{0xBFCA2DDD, 0x87A1F479}}, {{0xBC67E5CE, 0xF07409B2}}},
	{{{0x3FF0518C, 0xE908DA8C}}, {{0x3C987D18, 0x25A535E2}},
	  {{0xBFC9AB44, 0x34F46F10}}, {{0xBC1274BC, 0x57573053}}},
	{{{0x3FF04E5F, 0xA8C077CC}}, {{0xBC9D8190, 0xECF07BF2}},
	  {{0xBFC928C4, 0x8D8D4236}}, {{0xBC556048, 0x370EDF81}}},
	{{{0x3FF04B42, 0xB6D919A9}}, {{0xBC9F2338, 0x92AA0A0B}},
	  {{0xBFC8A65E, 0x0EECBBA5}}, {{0x3C6339DB, 0x0663DF15}}},
	{{{0x3FF04836, 0x1035CDFA}}, {{0xBC9E50AA, 0xBBC5EC1C}},
	  {{0xBFC82410, 0x36AC51DD}}, {{0xBC5A42DC, 0xDF8CB355}}},
	{{{0x3FF04539, 0xB1C9EDDA}}, {{0x3C8D2224, 0xC7598281}},
	  {{0xBFC7A1DA, 0x827E21C3}}, {{0xBC6CB79F, 0x06D46085}}},
	{{{0x3FF0424D, 0x98991A9F}}, {{0x3C66BB23, 0xA130683D}},
	  {{0xBFC71FBC, 0x702C6C4F}}, {{0xBC6BAA2A, 0x00C832DD}}},
	{{{0x3FF03F71, 0xC1B73AD9}}, {{0xBC885168, 0xA8202E85}},
	  {{0xBFC69DB5, 0x7D991458}}, {{0x3C69321C, 0x97B08BD2}}},
	{{{0x3FF03CA6, 0x2A487769}}, {{0xBC9585FD, 0xB95A2E63}},
	  {{0xBFC61BC5, 0x28BD1C73}}, {{0x3C625559, 0x2267ECEB}}},
	{{{0x3FF039EA, 0xCF8138A4}}, {{0x3C8ACC0C, 0x8FE6098D}},
	  {{0xBFC599EA, 0xEFA824F1}}, {{0x3C5F28E7, 0x2B9BA1A8}}},
	{{{0x3FF0373F, 0xAEA6238A}}, {{0xBC73E9A1, 0x72989A92}},
	  {{0xBFC51826, 0x507FE9EB}}, {{0x3C6AC219, 0x6946DA28}}},
	{{{0x3FF034A4, 0xC50C1706}}, {{0xBC8A9076, 0x7ECC2F29}},
	  {{0xBFC49676, 0xC97FC168}}, {{0x3C6B5D13, 0x93C07384}}},
	{{{0x3FF0321A, 0x10182946}}, {{0x3C88FA5C, 0xFE5F3FF1}},
	  {{0xBFC414DB, 0xD8F81999}}, {{0x3C3E1438, 0x0B2260AC}}},
	{{{0x3FF02F9F, 0x8D3FA521}}, {{0xBC58A44A, 0x88A18235}},
	  {{0xBFC39354, 0xFD4DF72A}}, {{0xBC4EAAC2, 0x64EC3B0C}}},
	{{{0x3FF02D35, 0x3A080789}}, {{0xBC907780, 0xF6C7E6F8}},
	  {{0xBFC311E1, 0xB4FA73A6}}, {{0x3C61065E, 0x4C87081D}}},
	{{{0x3FF02ADB, 0x1406FD12}}, {{0x3C969329, 0x720D8336}},
	  {{0xBFC29081, 0x7E8A3BEF}}, {{0x3C65A4E2, 0x8F21151D}}},
	{{{0x3FF02891, 0x18E25F8B}}, {{0xBC9A7DA4, 0x524ABA66}},
	  {{0xBFC20F33, 0xD89D0ECD}}, {{0x3C6557F7, 0x55A9198D}}},
	{{{0x3FF02657, 0x4650339C}}, {{0xBC31EC5D, 0x0688DD52}},
	  {{0xBFC18DF8, 0x41E53B8C}}, {{0xBC49852D, 0x50E682BB}}},
	{{{0x3FF0242D, 0x9A16A685}}, {{0xBC7352FD, 0x295277DB}},
	  {{0xBFC10CCE, 0x392720B0}}, {{0xBC55A291, 0x1E4C8E28}}},
	{{{0x3FF02214, 0x120C0BDE}}, {{0xBC9456D2, 0x6B72974E}},
	  {{0xBFC08BB5, 0x3D38AAB7}}, {{0xBC60FB6D, 0xD37D3177}}},
	{{{0x3FF0200A, 0xAC16DB6F}}, {{0xBC809B4F, 0x99576FC1}},
	  {{0xBFC00AAC, 0xCD00D2F1}}, {{0x3C53EA29, 0x146349DE}}},
	{{{0x3FF01E11, 0x662DAF18}}, {{0xBC833F82, 0x3120653C}},
	  {{0xBFBF1368, 0xCEEE3CC9}}, {{0x3C5213E7, 0x7BD924AB}}},
	{{{0x3FF01C28, 0x3E5740C5}}, {{0x3C95D295, 0x9EC02117}},
	  {{0xBFBE1197, 0x17463991}}, {{0xBC5E1FCA, 0x410E61A9}}},
	{{{0x3FF01A4F, 0x32AA6878}}, {{0x3C833FDA, 0x67BCC8B5}},
	  {{0xBFBD0FE3, 0x7137CF18}}, {{0x3C4AE71D, 0x698E234C}}},
	{{{0x3FF01886, 0x414E1A5C}}, {{0x3C4976C5, 0xE0B191DA}},
	  {{0xBFBC0E4C, 0xDB0F41D4}}, {{0x3C586525, 0xC9BFC58B}}},
	{{{0x3FF016CD, 0x687964EF}}, {{0xBC9D38AB, 0x209297AD}},
	  {{0xBFBB0CD2, 0x5335E625}}, {{0xBC480157, 0xFBDC145A}}},
	{{{0x3FF01524, 0xA6736F36}}, {{0x3C930803, 0xC450FC30}},
	  {{0xBFBA0B72, 0xD8311EBE}}, {{0xBC507AA8, 0x50193D71}}},
	{{{0x3FF0138B, 0xF993770A}}, {{0xBC7502E0, 0xB809A4D7}},
	  {{0xBFB90A2D, 0x68A15B27}}, {{0xBC5B1BE3, 0x7F556554}}},
	{{{0x3FF01203, 0x6040CF67}}, {{0x3C9847C0, 0x422FB0BC}},
	  {{0xBFB80901, 0x03411660}}, {{0xBC5DD342, 0x10739476}}},
	{{{0x3FF0108A, 0xD8F2DEDB}}, {{0x3C93DC21, 0x53B40698}},
	  {{0xBFB707EC, 0xA6E3D59B}}, {{0x3C5030B2, 0xF456FFFF}}},
	{{{0x3FF00F22, 0x62311DF8}}, {{0x3C99322E, 0xA7C410F3}},
	  {{0xBFB606EF, 0x5275270D}}, {{0x3C56910E, 0xE6EE4DC3}}},
	{{{0x3FF00DC9, 0xFA9315DF}}, {{0xBC84D0E2, 0x602B4C56}},
	  {{0xBFB50608, 0x04F7A0DD}}, {{0xBC239FF7, 0xEDAF37D2}}},
	{{{0x3FF00C81, 0xA0C05ED4}}, {{0xBC7736A7, 0x7A57AC2E}},
	  {{0xBFB40535, 0xBD83E026}}, {{0x3C4B9B73, 0x5F0B8AC5}}},
	{{{0x3FF00B49, 0x53709EEA}}, {{0xBC9DF4D4, 0xF8CDACD0}},
	  {{0xBFB30477, 0x7B47880C}}, {{0xBC517BE5, 0x3B77E1B2}}},
	{{{0x3FF00A21, 0x116B88B6}}, {{0xBC71D458, 0xAAAEC5A4}},
	  {{0xBFB203CC, 0x3D8440EF}}, {{0x3C1EF162, 0x41B5A4E1}}},
	{{{0x3FF00908, 0xD988DA1B}}, {{0x3C9519B1, 0x94C96CA5}},
	  {{0xBFB10333, 0x038EB7A7}}, {{0x3C044B95, 0x317BAEA7}}},
	{{{0x3FF00800, 0xAAB05B20}}, {{0xBC936EB9, 0x9FEBDB21}},
	  {{0xBFB002AA, 0xCCCD9CDD}}, {{0x3C53A7FD, 0xFAC9C47C}}},
	{{{0x3FF00708, 0x83D9DCD5}}, {{0xBC9EC747, 0x430DE399}},
	  {{0xBFAE0465, 0x317148DD}}, {{0x3C4B5DB1, 0x7929765A}}},
	{{{0x3FF00620, 0x640D384F}}, {{0xBC97FCBC, 0x170FB049}},
	  {{0xBFAC0392, 0xCDAF09CF}}, {{0x3C2B59CD, 0x7D4F7337}}},
	{{{0x3FF00548, 0x4A624DAE}}, {{0x3C5D0575, 0x23E9C180}},
	  {{0xBFAA02DC, 0x6D81EE12}}, {{0x3C2A5E3B, 0x7E00BA39}}},
	{{{0x3FF00480, 0x36010336}}, {{0xBC89227D, 0x10BEB244}},
	  {{0xBFA80240, 0x10336ABF}}, {{0x3C4941AF, 0xC229B627}}},
	{{{0x3FF003C8, 0x26214474}}, {{0xBC4AE17A, 0x45DFB29B}},
	  {{0xBFA601BB, 0xB526F7CF}}, {{0x3C39422F, 0x2DA1796B}}},
	{{{0x3FF00320, 0x1A0B0179}}, {{0x3C9FA45B, 0xD21A4C9A}},
	  {{0xBFA4014D, 0x5BD80F80}}, {{0xBC45A2E6, 0xA4813A5B}}},
	{{{0x3FF00288, 0x11162E22}}, {{0x3C6F0E22, 0x2A930764}},
	  {{0xBFA200F3, 0x03D82DD0}}, {{0xBC4BE9EF, 0x0CBDB96B}}},
	{{{0x3FF00200, 0x0AAAC16C}}, {{0x3C88618F, 0x578DDD8D}},
	  {{0xBFA000AA, 0xACCCD00D}}, {{0xBBFD9E59, 0x1EFF67C8}}},
	{{{0x3FF00188, 0x0640B4E1}}, {{0x3C7FB10F, 0x8827C989}},
	  {{0xBF9C00E4, 0xACDAE8F4}}, {{0xBBE94741, 0x22A0BAC6}}},
	{{{0x3FF00120, 0x0360040D}}, {{0xBC884C57, 0x402EAB5F}},
	  {{0xBF980090, 0x01033411}}, {{0xBC37E141, 0xDD340191}}},
	{{{0x3FF000C8, 0x01A0AC06}}, {{0xBC7BD6C4, 0x673A2EEE}},
	  {{0xBF940053, 0x55BD803E}}, {{0xBBD1997B, 0xCA73460D}}},
	{{{0x3FF00080, 0x00AAAB06}}, {{0xBC93E2BE, 0x2ABAD90D}},
	  {{0xBF90002A, 0xAACCCCDA}}, {{0x3C293021, 0x3AC1711C}}},
	{{{0x3FF00048, 0x00360010}}, {{0x3C899AE6, 0xDB8F0A40}},
	  {{0xBF880024, 0x00103337}}, {{0x3C250734, 0xAF88B300}}},
	{{{0x3FF00020, 0x000AAAAC}}, {{0x3C76C186, 0x1862ADFD}},
	  {{0xBF80000A, 0xAAACCCCD}}, {{0xBBBA01FC, 0x9193923E}}},
	{{{0x3FF00008, 0x0000AAAB}}, {{0xBC93E93E, 0x8D68D67B}},
	  {{0xBF700002, 0xAAAACCCD}}, {{0x3C093193, 0x17BFB4DB}}},
	{{{0x3FF00000, 0x00000000}}, {{0x00000000, 0x00000000}},
	  {{0x00000000, 0x00000000}}, {{0x00000000, 0x00000000}}},
	{{{0x3FF00008, 0x0000AAAB}}, {{0xBC93E93E, 0x8D68D67B}},
	  {{0x3F700002, 0xAAAACCCD}}, {{0xBC093193, 0x17BFB4DB}}},
	{{{0x3FF00020, 0x000AAAAC}}, {{0x3C76C186, 0x1862ADFD}},
	  {{0x3F80000A, 0xAAACCCCD}}, {{0x3BBA01FC, 0x9193923E}}},
	{{{0x3FF00048, 0x00360010}}, {{0x3C899AE6, 0xDB8F0A40}},
	  {{0x3F880024, 0x00103337}}, {{0xBC250734, 0xAF88B300}}},
	{{{0x3FF00080, 0x00AAAB06}}, {{0xBC93E2BE, 0x2ABAD90D}},
	  {{0x3F90002A, 0xAACCCCDA}}, {{0xBC293021, 0x3AC1711C}}},
	{{{0x3FF000C8, 0x01A0AC06}}, {{0xBC7BD6C4, 0x673A2EEE}},
	  {{0x3F940053, 0x55BD803E}}, {{0x3BD1997B, 0xCA73460D}}},
	{{{0x3FF00120, 0x0360040D}}, {{0xBC884C57, 0x402EAB5F}},
	  {{0x3F980090, 0x01033411}}, {{0x3C37E141, 0xDD340191}}},
	{{{0x3FF00188, 0x0640B4E1}}, {{0x3C7FB10F, 0x8827C989}},
	  {{0x3F9C00E4, 0xACDAE8F4}}, {{0x3BE94741, 0x22A0BAC6}}},
	{{{0x3FF00200, 0x0AAAC16C}}, {{0x3C88618F, 0x578DDD8D}},
	  {{0x3FA000AA, 0xACCCD00D}}, {{0x3BFD9E59, 0x1EFF67C8}}},
	{{{0x3FF00288, 0x11162E22}}, {{0x3C6F0E22, 0x2A930764}},
	  {{0x3FA200F3, 0x03D82DD0}}, {{0x3C4BE9EF, 0x0CBDB96B}}},
	{{{0x3FF00320, 0x1A0B0179}}, {{0x3C9FA45B, 0xD21A4C9A}},
	  {{0x3FA4014D, 0x5BD80F80}}, {{0x3C45A2E6, 0xA4813A5B}}},
	{{{0x3FF003C8, 0x26214474}}, {{0xBC4AE17A, 0x45DFB29B}},
	  {{0x3FA601BB, 0xB526F7CF}}, {{0xBC39422F, 0x2DA1796B}}},
	{{{0x3FF00480, 0x36010336}}, {{0xBC89227D, 0x10BEB244}},
	  {{0x3FA80240, 0x10336ABF}}, {{0xBC4941AF, 0xC229B627}}},
	{{{0x3FF00548, 0x4A624DAE}}, {{0x3C5D0575, 0x23E9C180}},
	  {{0x3FAA02DC, 0x6D81EE12}}, {{0xBC2A5E3B, 0x7E00BA39}}},
	{{{0x3FF00620, 0x640D384F}}, {{0xBC97FCBC, 0x170FB049}},
	  {{0x3FAC0392, 0xCDAF09CF}}, {{0xBC2B59CD, 0x7D4F7337}}},
	{{{0x3FF00708, 0x83D9DCD5}}, {{0xBC9EC747, 0x430DE399}},
	  {{0x3FAE0465, 0x317148DD}}, {{0xBC4B5DB1, 0x7929765A}}},
	{{{0x3FF00800, 0xAAB05B20}}, {{0xBC936EB9, 0x9FEBDB21}},
	  {{0x3FB002AA, 0xCCCD9CDD}}, {{0xBC53A7FD, 0xFAC9C47C}}},
	{{{0x3FF00908, 0xD988DA1B}}, {{0x3C9519B1, 0x94C96CA5}},
	  {{0x3FB10333, 0x038EB7A7}}, {{0xBC044B95, 0x317BAEA7}}},
	{{{0x3FF00A21, 0x116B88B6}}, {{0xBC71D458, 0xAAAEC5A4}},
	  {{0x3FB203CC, 0x3D8440EF}}, {{0xBC1EF162, 0x41B5A4E1}}},
	{{{0x3FF00B49, 0x53709EEA}}, {{0xBC9DF4D4, 0xF8CDACD0}},
	  {{0x3FB30477, 0x7B47880C}}, {{0x3C517BE5, 0x3B77E1B2}}},
	{{{0x3FF00C81, 0xA0C05ED4}}, {{0xBC7736A7, 0x7A57AC2E}},
	  {{0x3FB40535, 0xBD83E026}}, {{0xBC4B9B73, 0x5F0B8AC5}}},
	{{{0x3FF00DC9, 0xFA9315DF}}, {{0xBC84D0E2, 0x602B4C56}},
	  {{0x3FB50608, 0x04F7A0DD}}, {{0x3C239FF7, 0xEDAF37D2}}},
	{{{0x3FF00F22, 0x62311DF8}}, {{0x3C99322E, 0xA7C410F3}},
	  {{0x3FB606EF, 0x5275270D}}, {{0xBC56910E, 0xE6EE4DC3}}},
	{{{0x3FF0108A, 0xD8F2DEDB}}, {{0x3C93DC21, 0x53B40698}},
	  {{0x3FB707EC, 0xA6E3D59B}}, {{0xBC5030B2, 0xF456FFFF}}},
	{{{0x3FF01203, 0x6040CF67}}, {{0x3C9847C0, 0x422FB0BC}},
	  {{0x3FB80901, 0x03411660}}, {{0x3C5DD342, 0x10739476}}},
	{{{0x3FF0138B, 0xF993770A}}, {{0xBC7502E0, 0xB809A4D7}},
	  {{0x3FB90A2D, 0x68A15B27}}, {{0x3C5B1BE3, 0x7F556554}}},
	{{{0x3FF01524, 0xA6736F36}}, {{0x3C930803, 0xC450FC30}},
	  {{0x3FBA0B72, 0xD8311EBE}}, {{0x3C507AA8, 0x50193D71}}},
	{{{0x3FF016CD, 0x687964EF}}, {{0xBC9D38AB, 0x209297AD}},
	  {{0x3FBB0CD2, 0x5335E625}}, {{0x3C480157, 0xFBDC145A}}},
	{{{0x3FF01886, 0x414E1A5C}}, {{0x3C4976C5, 0xE0B191DA}},
	  {{0x3FBC0E4C, 0xDB0F41D4}}, {{0xBC586525, 0xC9BFC58B}}},
	{{{0x3FF01A4F, 0x32AA6878}}, {{0x3C833FDA, 0x67BCC8B5}},
	  {{0x3FBD0FE3, 0x7137CF18}}, {{0xBC4AE71D, 0x698E234C}}},
	{{{0x3FF01C28, 0x3E5740C5}}, {{0x3C95D295, 0x9EC02117}},
	  {{0x3FBE1197, 0x17463991}}, {{0x3C5E1FCA, 0x410E61A9}}},
	{{{0x3FF01E11, 0x662DAF18}}, {{0xBC833F82, 0x3120653C}},
	  {{0x3FBF1368, 0xCEEE3CC9}}, {{0xBC5213E7, 0x7BD924AB}}},
	{{{0x3FF0200A, 0xAC16DB6F}}, {{0xBC809B4F, 0x99576FC1}},
	  {{0x3FC00AAC, 0xCD00D2F1}}, {{0xBC53EA29, 0x146349DE}}},
	{{{0x3FF02214, 0x120C0BDE}}, {{0xBC9456D2, 0x6B72974E}},
	  {{0x3FC08BB5, 0x3D38AAB7}}, {{0x3C60FB6D, 0xD37D3177}}},
	{{{0x3FF0242D, 0x9A16A685}}, {{0xBC7352FD, 0x295277DB}},
	  {{0x3FC10CCE, 0x392720B0}}, {{0x3C55A291, 0x1E4C8E28}}},
	{{{0x3FF02657, 0x4650339C}}, {{0xBC31EC5D, 0x0688DD52}},
	  {{0x3FC18DF8, 0x41E53B8C}}, {{0x3C49852D, 0x50E682BB}}},
	{{{0x3FF02891, 0x18E25F8B}}, {{0xBC9A7DA4, 0x524ABA66}},
	  {{0x3FC20F33, 0xD89D0ECD}}, {{0xBC6557F7, 0x55A9198D}}},
	{{{0x3FF02ADB, 0x1406FD12}}, {{0x3C969329, 0x720D8336}},
	  {{0x3FC29081, 0x7E8A3BEF}}, {{0xBC65A4E2, 0x8F21151D}}},
	{{{0x3FF02D35, 0x3A080789}}, {{0xBC907780, 0xF6C7E6F8}},
	  {{0x3FC311E1, 0xB4FA73A6}}, {{0xBC61065E, 0x4C87081D}}},
	{{{0x3FF02F9F, 0x8D3FA521}}, {{0xBC58A44A, 0x88A18235}},
	  {{0x3FC39354, 0xFD4DF72A}}, {{0x3C4EAAC2, 0x64EC3B0C}}},
	{{{0x3FF0321A, 0x10182946}}, {{0x3C88FA5C, 0xFE5F3FF1}},
	  {{0x3FC414DB, 0xD8F81999}}, {{0xBC3E1438, 0x0B2260AC}}},
	{{{0x3FF034A4, 0xC50C1706}}, {{0xBC8A9076, 0x7ECC2F29}},
	  {{0x3FC49676, 0xC97FC168}}, {{0xBC6B5D13, 0x93C07384}}},
	{{{0x3FF0373F, 0xAEA6238A}}, {{0xBC73E9A1, 0x72989A92}},
	  {{0x3FC51826, 0x507FE9EB}}, {{0xBC6AC219, 0x6946DA28}}},
	{{{0x3FF039EA, 0xCF8138A4}}, {{0x3C8ACC0C, 0x8FE6098D}},
	  {{0x3FC599EA, 0xEFA824F1}}, {{0xBC5F28E7, 0x2B9BA1A8}}},
	{{{0x3FF03CA6, 0x2A487769}}, {{0xBC9585FD, 0xB95A2E63}},
	  {{0x3FC61BC5, 0x28BD1C73}}, {{0xBC625559, 0x2267ECEB}}},
	{{{0x3FF03F71, 0xC1B73AD9}}, {{0xBC885168, 0xA8202E85}},
	  {{0x3FC69DB5, 0x7D991458}}, {{0xBC69321C, 0x97B08BD2}}},
	{{{0x3FF0424D, 0x98991A9F}}, {{0x3C66BB23, 0xA130683D}},
	  {{0x3FC71FBC, 0x702C6C4F}}, {{0x3C6BAA2A, 0x00C832DD}}},
	{{{0x3FF04539, 0xB1C9EDDA}}, {{0x3C8D2224, 0xC7598281}},
	  {{0x3FC7A1DA, 0x827E21C3}}, {{0x3C6CB79F, 0x06D46085}}},
	{{{0x3FF04836, 0x1035CDFA}}, {{0xBC9E50AA, 0xBBC5EC1C}},
	  {{0x3FC82410, 0x36AC51DD}}, {{0x3C5A42DC, 0xDF8CB355}}},
	{{{0x3FF04B42, 0xB6D919A9}}, {{0xBC9F2338, 0x92AA0A0B}},
	  {{0x3FC8A65E, 0x0EECBBA5}}, {{0xBC6339DB, 0x0663DF15}}},
	{{{0x3FF04E5F, 0xA8C077CC}}, {{0xBC9D8190, 0xECF07BF2}},
	  {{0x3FC928C4, 0x8D8D4236}}, {{0x3C556048, 0x370EDF81}}},
	{{{0x3FF0518C, 0xE908DA8C}}, {{0x3C987D18, 0x25A535E2}},
	  {{0x3FC9AB44, 0x34F46F10}}, {{0x3C1274BC, 0x57573053}}},
	{{{0x3FF054CA, 0x7ADF8277}}, {{0x3C89C0C1, 0x377A9F8C}},
	  {{0x3FCA2DDD, 0x87A1F479}}, {{0x3C67E5CE, 0xF07409B2}}},
	{{{0x3FF05818, 0x618201A8}}, {{0xBC8BFA98, 0x5A557953}},
	  {{0x3FCAB091, 0x082F3002}}, {{0xBC4B6626, 0x60BF022C}}},
	{{{0x3FF05B76, 0xA03E3F07}}, {{0x3C7CA615, 0x2B52E765}},
	  {{0x3FCB335F, 0x394FAD1B}}, {{0x3C47F257, 0x34B51ACE}}},
	{{{0x3FF05EE5, 0x3A727999}}, {{0x3C92512F, 0x6647668D}},
	  {{0x3FCBB648, 0x9DD1A7CC}}, {{0xBC234425, 0x3ED3824D}}},
	{{{0x3FF06264, 0x338D4BDC}}, {{0xBC90000F, 0xF34422A4}},
	  {{0x3FCC394D, 0xB89E8F7F}}, {{0x3C646F77, 0x52292D2D}}},
	{{{0x3FF065F3, 0x8F0DAF34}}, {{0xBC7821B3, 0xAF1520A9}},
	  {{0x3FCCBC6F, 0x0CBB89ED}}, {{0x3C4B40A0, 0x51092884}}},
	{{{0x3FF06993, 0x5082FF6E}}, {{0x3C7685C4, 0xD7395A9F}},
	  {{0x3FCD3FAD, 0x1D49F620}}, {{0xBC5DE851, 0x26ECE4F0}}},
	{{{0x3FF06D43, 0x7B8CFE4D}}, {{0xBC73ADF7, 0xD1025E7E}},
	  {{0x3FCDC308, 0x6D87EF96}}, {{0xBC6C0BD9, 0x2A97B34C}}},
	{{{0x3FF07104, 0x13DBD729}}, {{0x3C766560, 0xCA5328ED}},
	  {{0x3FCE4681, 0x80D0D17F}}, {{0xBC605627, 0x658D0660}}},
	{{{0x3FF074D5, 0x1D3022A1}}, {{0x3C9E93F8, 0x2426EF93}},
	  {{0x3FCECA18, 0xDA9DBA19}}, {{0xBC36D470, 0x491D8A98}}},
	{{{0x3FF078B6, 0x9B5AEA5C}}, {{0xBC8880D6, 0x6B6D819B}},
	  {{0x3FCF4DCE, 0xFE860E28}}, {{0x3C6883D4, 0xC6A2C678}}},
	{{{0x3FF07CA8, 0x923DACD6}}, {{0xBC9653A7, 0xE736D67A}},
	  {{0x3FCFD1A4, 0x703FFC8F}}, {{0x3C59EA3B, 0xA8860819}}},
	{{{0x3FF080AB, 0x05CA6146}}, {{0xBC723216, 0xFC66378F}},
	  {{0x3FD02ACC, 0xD9D08102}}, {{0xBC5998B3, 0x20C03715}}},
	{{{0x3FF084BD, 0xFA037B8F}}, {{0xBC7D97E2, 0xE3C5EBFC}},
	  {{0x3FD06CD7, 0xA64F3673}}, {{0x3C6370BA, 0x839871E4}}},
	{{{0x3FF088E1, 0x72FBF041}}, {{0xBC9DE12F, 0x0D55140F}},
	  {{0x3FD0AEF2, 0xDFA6F09B}}, {{0xBC414E60, 0xA7827088}}},
	{{{0x3FF08D15, 0x74D738AC}}, {{0xBC984BD5, 0xC4A8C043}},
	  {{0x3FD0F11E, 0xC7F2EE53}}, {{0x3C75BADF, 0xC5355AFC}}},
	{{{0x3FF0915A, 0x03C95705}}, {{0x3C78A8A6, 0x0BD1CD00}},
	  {{0x3FD1335B, 0xA15F1D6C}}, {{0xBC53CE0F, 0x341ED7B6}}},
	{{{0x3FF095AF, 0x2416DA9A}}, {{0x3C8024A0, 0x39DC7749}},
	  {{0x3FD175A9, 0xAE285CD6}}, {{0xBC3DB749, 0xC4496E39}}},
	{{{0x3FF09A14, 0xDA14E415}}, {{0xBC965668, 0x233B29C8}},
	  {{0x3FD1B809, 0x309CBEE1}}, {{0x3C6E5B16, 0xBBB1CB75}}},
	{{{0x3FF09E8B, 0x2A2929D1}}, {{0xBC9EE5F5, 0x535446B4}},
	  {{0x3FD1FA7A, 0x6B1BCB8A}}, {{0x3C50621A, 0x5A4CB636}}},
	{{{0x3FF0A312, 0x18C9FC41}}, {{0x3C885259, 0x09E044C2}},
	  {{0x3FD23CFD, 0xA016C2D9}}, {{0xBC500762, 0x449D986B}}},
	{{{0x3FF0A7A9, 0xAA7E4A68}}, {{0x3C71B296, 0x281520E0}},
	  {{0x3FD27F93, 0x1210DF54}}, {{0xBC6EF999, 0x502A1E59}}},
	{{{0x3FF0AC51, 0xE3DDA65B}}, {{0x3C9B22C0, 0x9DACA977}},
	  {{0x3FD2C23B, 0x039F9881}}, {{0x3C577301, 0x9B082732}}},
	{{{0x3FF0B10A, 0xC99049DE}}, {{0xBC617C2D, 0x610FCC2E}},
	  {{0x3FD304F5, 0xB76AE57E}}, {{0xBC75EB09, 0x42E4CA9C}}},
	{{{0x3FF0B5D4, 0x604F1B07}}, {{0x3C732C14, 0x07EECFA5}},
	  {{0x3FD347C3, 0x702D7FA4}}, {{0x3C7435BE, 0x701422C8}}},
	{{{0x3FF0BAAE, 0xACE3B0FC}}, {{0xBC93292F, 0x75521E77}},
	  {{0x3FD38AA4, 0x70B52549}}, {{0xBC67F94B, 0x0B01B8A6}}},
	{{{0x3FF0BF99, 0xB42858B8}}, {{0xBC67AD83, 0x0B1F30A5}},
	  {{0x3FD3CD98, 0xFBE2DC86}}, {{0xBC7D0A5E, 0x269038FC}}},
	{{{0x3FF0C495, 0x7B0819E9}}, {{0x3C9A26E0, 0x6E52BA24}},
	  {{0x3FD410A1, 0x54AB361D}}, {{0xBC78DCB6, 0xCF7DA2E8}}},
	{{{0x3FF0C9A2, 0x067EBBDA}}, {{0x3C813CD8, 0x803D61F3}},
	  {{0x3FD453BD, 0xBE16906C}}, {{0x3C78D781, 0x45D8536E}}},
	{{{0x3FF0CEBF, 0x5B98CA6C}}, {{0x3C9E8080, 0x09B9F220}},
	  {{0x3FD496EE, 0x7B415A78}}, {{0xBC51C3BA, 0xBDFE61F1}}},
	{{{0x3FF0D3ED, 0x7F739B28}}, {{0xBC99722F, 0xEA8A9ED5}},
	  {{0x3FD4DA33, 0xCF5C5703}}, {{0x3C7B1F07, 0x7BE71FBE}}},
	{{{0x3FF0D92C, 0x773D5255}}, {{0xBC84956C, 0x3D5D1DA2}},
	  {{0x3FD51D8D, 0xFDACDFC5}}, {{0xBC419F0E, 0x98966B86}}},
	{{{0x3FF0DE7C, 0x4834E82E}}, {{0xBC877BEC, 0x5F430E44}},
	  {{0x3FD560FD, 0x498D28AA}}, {{0xBC4F07B3, 0xCCEA8A26}}},
	{{{0x3FF0E3DC, 0xF7AA2E1B}}, {{0x3C9C05BD, 0xF7FB3140}},
	  {{0x3FD5A481, 0xF66C8331}}, {{0x3C6E8E0C, 0xCFF78DD1}}},
	{{{0x3FF0E94E, 0x8AFDD406}}, {{0xBC9330CB, 0xB0B14F49}},
	  {{0x3FD5E81C, 0x47CFA1DB}}, {{0xBC791EC5, 0x4E7B2C63}}},
	{{{0x3FF0EED1, 0x07A16DB4}}, {{0x3C988108, 0xD3E071F5}},
	  {{0x3FD62BCC, 0x8150DBAB}}, {{0x3C7700BD, 0xF95D00CA}}},
	{{{0x3FF0F464, 0x73177841}}, {{0xBC97DF60, 0x29551C51}},
	  {{0x3FD66F92, 0xE6A06FC9}}, {{0xBC70A785, 0xD9A66B42}}},
	{{{0x3FF0FA08, 0xD2F35F97}}, {{0x3C9B39D1, 0x9DAB3AF1}},
	  {{0x3FD6B36F, 0xBB84C928}}, {{0x3C68DAF8, 0xFEFE1E5F}}},
}; 
/* the coefficients for the cosh-approximations */ 
  static const db_number c0 =   {{0x3FF00000,0x00000000}};     /*1.0000000000e+00*/  
  static const db_number c2 =   {{0x3FE00000,0x00000000}};     /*5.0000000000e-01*/  
  static const db_number c4 =   {{0x3FA55555,0x55555555}};     /*4.1666666667e-02*/  
  static const db_number c6 =   {{0x3F56C16C,0x16C16C17}};     /*1.3888888889e-03*/  
  static const db_number c8 =   {{0x3EFA01A0,0x1A01A01A}};     /*2.4801587302e-05*/  
/* the coefficients for the sinh-approximations */
  static  const db_number s1 =   {{0x3FF00000,0x00000000}};     /*1.0000000000e+00*/  
  static  const db_number s3 =   {{0x3FC55555,0x55555555}};     /*1.6666666667e-01*/  
  static  const db_number s5 =   {{0x3F811111,0x11111111}};     /*8.3333333333e-03*/  
  static  const db_number s7 =   {{0x3F2A01A0,0x1A01A01A}};     /*1.9841269841e-04*/  
#else  
  static db_number const inv_ln_2 =     {{0x652B82FE,0x3FF71547}};     /*1.4426950409e+00*/  
  static db_number const ln2_hi =       {{0xFEFA3800,0x3FE62E42}};     /*6.9314718056e-01*/  
  static db_number const ln2_lo =       {{0x93C76730,0x3D2EF357}};     /*5.4979230187e-14*/  
  static db_number const two_43_44 =    {{0x00000000,0x42B80000}};     /*2.6388279067e+13*/  
  static db_number const two_minus_30 = {{0x00000000,0x3D700000}};     /*9.0949470177e-13*/  
  static int const bias = 89 ;

/* some bounds */ 
  static db_number const max_input_csh =  {{0x8FB9F87E,0x408633CE}};     /*7.1047586007e+02*/  

  static const db_number cosh_sinh_table[179][4] = { 
	{{{0xD2F35F97, 0x3FF0FA08}}, {{0x9DAB3AF1, 0x3C9B39D1}},
	  {{0xBB84C928, 0xBFD6B36F}}, {{0xFEFE1E5F, 0xBC68DAF8}}},
	{{{0x73177841, 0x3FF0F464}}, {{0x29551C51, 0xBC97DF60}},
	  {{0xE6A06FC9, 0xBFD66F92}}, {{0xD9A66B42, 0x3C70A785}}},
	{{{0x07A16DB4, 0x3FF0EED1}}, {{0xD3E071F5, 0x3C988108}},
	  {{0x8150DBAB, 0xBFD62BCC}}, {{0xF95D00CA, 0xBC7700BD}}},
	{{{0x8AFDD406, 0x3FF0E94E}}, {{0xB0B14F49, 0xBC9330CB}},
	  {{0x47CFA1DB, 0xBFD5E81C}}, {{0x4E7B2C63, 0x3C791EC5}}},
	{{{0xF7AA2E1B, 0x3FF0E3DC}}, {{0xF7FB3140, 0x3C9C05BD}},
	  {{0xF66C8331, 0xBFD5A481}}, {{0xCFF78DD1, 0xBC6E8E0C}}},
	{{{0x4834E82E, 0x3FF0DE7C}}, {{0x5F430E44, 0xBC877BEC}},
	  {{0x498D28AA, 0xBFD560FD}}, {{0xCCEA8A26, 0x3C4F07B3}}},
	{{{0x773D5255, 0x3FF0D92C}}, {{0x3D5D1DA2, 0xBC84956C}},
	  {{0xFDACDFC5, 0xBFD51D8D}}, {{0x98966B86, 0x3C419F0E}}},
	{{{0x7F739B28, 0x3FF0D3ED}}, {{0xEA8A9ED5, 0xBC99722F}},
	  {{0xCF5C5703, 0xBFD4DA33}}, {{0x7BE71FBE, 0xBC7B1F07}}},
	{{{0x5B98CA6C, 0x3FF0CEBF}}, {{0x09B9F220, 0x3C9E8080}},
	  {{0x7B415A78, 0xBFD496EE}}, {{0xBDFE61F1, 0x3C51C3BA}}},
	{{{0x067EBBDA, 0x3FF0C9A2}}, {{0x803D61F3, 0x3C813CD8}},
	  {{0xBE16906C, 0xBFD453BD}}, {{0x45D8536E, 0xBC78D781}}},
	{{{0x7B0819E9, 0x3FF0C495}}, {{0x6E52BA24, 0x3C9A26E0}},
	  {{0x54AB361D, 0xBFD410A1}}, {{0xCF7DA2E8, 0x3C78DCB6}}},
	{{{0xB42858B8, 0x3FF0BF99}}, {{0x0B1F30A5, 0xBC67AD83}},
	  {{0xFBE2DC86, 0xBFD3CD98}}, {{0x269038FC, 0x3C7D0A5E}}},
	{{{0xACE3B0FC, 0x3FF0BAAE}}, {{0x75521E77, 0xBC93292F}},
	  {{0x70B52549, 0xBFD38AA4}}, {{0x0B01B8A6, 0x3C67F94B}}},
	{{{0x604F1B07, 0x3FF0B5D4}}, {{0x07EECFA5, 0x3C732C14}},
	  {{0x702D7FA4, 0xBFD347C3}}, {{0x701422C8, 0xBC7435BE}}},
	{{{0xC99049DE, 0x3FF0B10A}}, {{0x610FCC2E, 0xBC617C2D}},
	  {{0xB76AE57E, 0xBFD304F5}}, {{0x42E4CA9C, 0x3C75EB09}}},
	{{{0xE3DDA65B, 0x3FF0AC51}}, {{0x9DACA977, 0x3C9B22C0}},
	  {{0x039F9881, 0xBFD2C23B}}, {{0x9B082732, 0xBC577301}}},
	{{{0xAA7E4A68, 0x3FF0A7A9}}, {{0x281520E0, 0x3C71B296}},
	  {{0x1210DF54, 0xBFD27F93}}, {{0x502A1E59, 0x3C6EF999}}},
	{{{0x18C9FC41, 0x3FF0A312}}, {{0x09E044C2, 0x3C885259}},
	  {{0xA016C2D9, 0xBFD23CFD}}, {{0x449D986B, 0x3C500762}}},
	{{{0x2A2929D1, 0x3FF09E8B}}, {{0x535446B4, 0xBC9EE5F5}},
	  {{0x6B1BCB8A, 0xBFD1FA7A}}, {{0x5A4CB636, 0xBC50621A}}},
	{{{0xDA14E415, 0x3FF09A14}}, {{0x233B29C8, 0xBC965668}},
	  {{0x309CBEE1, 0xBFD1B809}}, {{0xBBB1CB75, 0xBC6E5B16}}},
	{{{0x2416DA9A, 0x3FF095AF}}, {{0x39DC7749, 0x3C8024A0}},
	  {{0xAE285CD6, 0xBFD175A9}}, {{0xC4496E39, 0x3C3DB749}}},
	{{{0x03C95705, 0x3FF0915A}}, {{0x0BD1CD00, 0x3C78A8A6}},
	  {{0xA15F1D6C, 0xBFD1335B}}, {{0x341ED7B6, 0x3C53CE0F}}},
	{{{0x74D738AC, 0x3FF08D15}}, {{0xC4A8C043, 0xBC984BD5}},
	  {{0xC7F2EE53, 0xBFD0F11E}}, {{0xC5355AFC, 0xBC75BADF}}},
	{{{0x72FBF041, 0x3FF088E1}}, {{0x0D55140F, 0xBC9DE12F}},
	  {{0xDFA6F09B, 0xBFD0AEF2}}, {{0xA7827088, 0x3C414E60}}},
	{{{0xFA037B8F, 0x3FF084BD}}, {{0xE3C5EBFC, 0xBC7D97E2}},
	  {{0xA64F3673, 0xBFD06CD7}}, {{0x839871E4, 0xBC6370BA}}},
	{{{0x05CA6146, 0x3FF080AB}}, {{0xFC66378F, 0xBC723216}},
	  {{0xD9D08102, 0xBFD02ACC}}, {{0x20C03715, 0x3C5998B3}}},
	{{{0x923DACD6, 0x3FF07CA8}}, {{0xE736D67A, 0xBC9653A7}},
	  {{0x703FFC8F, 0xBFCFD1A4}}, {{0xA8860819, 0xBC59EA3B}}},
	{{{0x9B5AEA5C, 0x3FF078B6}}, {{0x6B6D819B, 0xBC8880D6}},
	  {{0xFE860E28, 0xBFCF4DCE}}, {{0xC6A2C678, 0xBC6883D4}}},
	{{{0x1D3022A1, 0x3FF074D5}}, {{0x2426EF93, 0x3C9E93F8}},
	  {{0xDA9DBA19, 0xBFCECA18}}, {{0x491D8A98, 0x3C36D470}}},
	{{{0x13DBD729, 0x3FF07104}}, {{0xCA5328ED, 0x3C766560}},
	  {{0x80D0D17F, 0xBFCE4681}}, {{0x658D0660, 0x3C605627}}},
	{{{0x7B8CFE4D, 0x3FF06D43}}, {{0xD1025E7E, 0xBC73ADF7}},
	  {{0x6D87EF96, 0xBFCDC308}}, {{0x2A97B34C, 0x3C6C0BD9}}},
	{{{0x5082FF6E, 0x3FF06993}}, {{0xD7395A9F, 0x3C7685C4}},
	  {{0x1D49F620, 0xBFCD3FAD}}, {{0x26ECE4F0, 0x3C5DE851}}},
	{{{0x8F0DAF34, 0x3FF065F3}}, {{0xAF1520A9, 0xBC7821B3}},
	  {{0x0CBB89ED, 0xBFCCBC6F}}, {{0x51092884, 0xBC4B40A0}}},
	{{{0x338D4BDC, 0x3FF06264}}, {{0xF34422A4, 0xBC90000F}},
	  {{0xB89E8F7F, 0xBFCC394D}}, {{0x52292D2D, 0xBC646F77}}},
	{{{0x3A727999, 0x3FF05EE5}}, {{0x6647668D, 0x3C92512F}},
	  {{0x9DD1A7CC, 0xBFCBB648}}, {{0x3ED3824D, 0x3C234425}}},
	{{{0xA03E3F07, 0x3FF05B76}}, {{0x2B52E765, 0x3C7CA615}},
	  {{0x394FAD1B, 0xBFCB335F}}, {{0x34B51ACE, 0xBC47F257}}},
	{{{0x618201A8, 0x3FF05818}}, {{0x5A557953, 0xBC8BFA98}},
	  {{0x082F3002, 0xBFCAB091}}, {{0x60BF022C, 0x3C4B6626}}},
	{{{0x7ADF8277, 0x3FF054CA}}, {{0x377A9F8C, 0x3C89C0C1}},
	  {{0x87A1F479, 0xBFCA2DDD}}, {{0xF07409B2, 0xBC67E5CE}}},
	{{{0xE908DA8C, 0x3FF0518C}}, {{0x25A535E2, 0x3C987D18}},
	  {{0x34F46F10, 0xBFC9AB44}}, {{0x57573053, 0xBC1274BC}}},
	{{{0xA8C077CC, 0x3FF04E5F}}, {{0xECF07BF2, 0xBC9D8190}},
	  {{0x8D8D4236, 0xBFC928C4}}, {{0x370EDF81, 0xBC556048}}},
	{{{0xB6D919A9, 0x3FF04B42}}, {{0x92AA0A0B, 0xBC9F2338}},
	  {{0x0EECBBA5, 0xBFC8A65E}}, {{0x0663DF15, 0x3C6339DB}}},
	{{{0x1035CDFA, 0x3FF04836}}, {{0xBBC5EC1C, 0xBC9E50AA}},
	  {{0x36AC51DD, 0xBFC82410}}, {{0xDF8CB355, 0xBC5A42DC}}},
	{{{0xB1C9EDDA, 0x3FF04539}}, {{0xC7598281, 0x3C8D2224}},
	  {{0x827E21C3, 0xBFC7A1DA}}, {{0x06D46085, 0xBC6CB79F}}},
	{{{0x98991A9F, 0x3FF0424D}}, {{0xA130683D, 0x3C66BB23}},
	  {{0x702C6C4F, 0xBFC71FBC}}, {{0x00C832DD, 0xBC6BAA2A}}},
	{{{0xC1B73AD9, 0x3FF03F71}}, {{0xA8202E85, 0xBC885168}},
	  {{0x7D991458, 0xBFC69DB5}}, {{0x97B08BD2, 0x3C69321C}}},
	{{{0x2A487769, 0x3FF03CA6}}, {{0xB95A2E63, 0xBC9585FD}},
	  {{0x28BD1C73, 0xBFC61BC5}}, {{0x2267ECEB, 0x3C625559}}},
	{{{0xCF8138A4, 0x3FF039EA}}, {{0x8FE6098D, 0x3C8ACC0C}},
	  {{0xEFA824F1, 0xBFC599EA}}, {{0x2B9BA1A8, 0x3C5F28E7}}},
	{{{0xAEA6238A, 0x3FF0373F}}, {{0x72989A92, 0xBC73E9A1}},
	  {{0x507FE9EB, 0xBFC51826}}, {{0x6946DA28, 0x3C6AC219}}},
	{{{0xC50C1706, 0x3FF034A4}}, {{0x7ECC2F29, 0xBC8A9076}},
	  {{0xC97FC168, 0xBFC49676}}, {{0x93C07384, 0x3C6B5D13}}},
	{{{0x10182946, 0x3FF0321A}}, {{0xFE5F3FF1, 0x3C88FA5C}},
	  {{0xD8F81999, 0xBFC414DB}}, {{0x0B2260AC, 0x3C3E1438}}},
	{{{0x8D3FA521, 0x3FF02F9F}}, {{0x88A18235, 0xBC58A44A}},
	  {{0xFD4DF72A, 0xBFC39354}}, {{0x64EC3B0C, 0xBC4EAAC2}}},
	{{{0x3A080789, 0x3FF02D35}}, {{0xF6C7E6F8, 0xBC907780}},
	  {{0xB4FA73A6, 0xBFC311E1}}, {{0x4C87081D, 0x3C61065E}}},
	{{{0x1406FD12, 0x3FF02ADB}}, {{0x720D8336, 0x3C969329}},
	  {{0x7E8A3BEF, 0xBFC29081}}, {{0x8F21151D, 0x3C65A4E2}}},
	{{{0x18E25F8B, 0x3FF02891}}, {{0x524ABA66, 0xBC9A7DA4}},
	  {{0xD89D0ECD, 0xBFC20F33}}, {{0x55A9198D, 0x3C6557F7}}},
	{{{0x4650339C, 0x3FF02657}}, {{0x0688DD52, 0xBC31EC5D}},
	  {{0x41E53B8C, 0xBFC18DF8}}, {{0x50E682BB, 0xBC49852D}}},
	{{{0x9A16A685, 0x3FF0242D}}, {{0x295277DB, 0xBC7352FD}},
	  {{0x392720B0, 0xBFC10CCE}}, {{0x1E4C8E28, 0xBC55A291}}},
	{{{0x120C0BDE, 0x3FF02214}}, {{0x6B72974E, 0xBC9456D2}},
	  {{0x3D38AAB7, 0xBFC08BB5}}, {{0xD37D3177, 0xBC60FB6D}}},
	{{{0xAC16DB6F, 0x3FF0200A}}, {{0x99576FC1, 0xBC809B4F}},
	  {{0xCD00D2F1, 0xBFC00AAC}}, {{0x146349DE, 0x3C53EA29}}},
	{{{0x662DAF18, 0x3FF01E11}}, {{0x3120653C, 0xBC833F82}},
	  {{0xCEEE3CC9, 0xBFBF1368}}, {{0x7BD924AB, 0x3C5213E7}}},
	{{{0x3E5740C5, 0x3FF01C28}}, {{0x9EC02117, 0x3C95D295}},
	  {{0x17463991, 0xBFBE1197}}, {{0x410E61A9, 0xBC5E1FCA}}},
	{{{0x32AA6878, 0x3FF01A4F}}, {{0x67BCC8B5, 0x3C833FDA}},
	  {{0x7137CF18, 0xBFBD0FE3}}, {{0x698E234C, 0x3C4AE71D}}},
	{{{0x414E1A5C, 0x3FF01886}}, {{0xE0B191DA, 0x3C4976C5}},
	  {{0xDB0F41D4, 0xBFBC0E4C}}, {{0xC9BFC58B, 0x3C586525}}},
	{{{0x687964EF, 0x3FF016CD}}, {{0x209297AD, 0xBC9D38AB}},
	  {{0x5335E625, 0xBFBB0CD2}}, {{0xFBDC145A, 0xBC480157}}},
	{{{0xA6736F36, 0x3FF01524}}, {{0xC450FC30, 0x3C930803}},
	  {{0xD8311EBE, 0xBFBA0B72}}, {{0x50193D71, 0xBC507AA8}}},
	{{{0xF993770A, 0x3FF0138B}}, {{0xB809A4D7, 0xBC7502E0}},
	  {{0x68A15B27, 0xBFB90A2D}}, {{0x7F556554, 0xBC5B1BE3}}},
	{{{0x6040CF67, 0x3FF01203}}, {{0x422FB0BC, 0x3C9847C0}},
	  {{0x03411660, 0xBFB80901}}, {{0x10739476, 0xBC5DD342}}},
	{{{0xD8F2DEDB, 0x3FF0108A}}, {{0x53B40698, 0x3C93DC21}},
	  {{0xA6E3D59B, 0xBFB707EC}}, {{0xF456FFFF, 0x3C5030B2}}},
	{{{0x62311DF8, 0x3FF00F22}}, {{0xA7C410F3, 0x3C99322E}},
	  {{0x5275270D, 0xBFB606EF}}, {{0xE6EE4DC3, 0x3C56910E}}},
	{{{0xFA9315DF, 0x3FF00DC9}}, {{0x602B4C56, 0xBC84D0E2}},
	  {{0x04F7A0DD, 0xBFB50608}}, {{0xEDAF37D2, 0xBC239FF7}}},
	{{{0xA0C05ED4, 0x3FF00C81}}, {{0x7A57AC2E, 0xBC7736A7}},
	  {{0xBD83E026, 0xBFB40535}}, {{0x5F0B8AC5, 0x3C4B9B73}}},
	{{{0x53709EEA, 0x3FF00B49}}, {{0xF8CDACD0, 0xBC9DF4D4}},
	  {{0x7B47880C, 0xBFB30477}}, {{0x3B77E1B2, 0xBC517BE5}}},
	{{{0x116B88B6, 0x3FF00A21}}, {{0xAAAEC5A4, 0xBC71D458}},
	  {{0x3D8440EF, 0xBFB203CC}}, {{0x41B5A4E1, 0x3C1EF162}}},
	{{{0xD988DA1B, 0x3FF00908}}, {{0x94C96CA5, 0x3C9519B1}},
	  {{0x038EB7A7, 0xBFB10333}}, {{0x317BAEA7, 0x3C044B95}}},
	{{{0xAAB05B20, 0x3FF00800}}, {{0x9FEBDB21, 0xBC936EB9}},
	  {{0xCCCD9CDD, 0xBFB002AA}}, {{0xFAC9C47C, 0x3C53A7FD}}},
	{{{0x83D9DCD5, 0x3FF00708}}, {{0x430DE399, 0xBC9EC747}},
	  {{0x317148DD, 0xBFAE0465}}, {{0x7929765A, 0x3C4B5DB1}}},
	{{{0x640D384F, 0x3FF00620}}, {{0x170FB049, 0xBC97FCBC}},
	  {{0xCDAF09CF, 0xBFAC0392}}, {{0x7D4F7337, 0x3C2B59CD}}},
	{{{0x4A624DAE, 0x3FF00548}}, {{0x23E9C180, 0x3C5D0575}},
	  {{0x6D81EE12, 0xBFAA02DC}}, {{0x7E00BA39, 0x3C2A5E3B}}},
	{{{0x36010336, 0x3FF00480}}, {{0x10BEB244, 0xBC89227D}},
	  {{0x10336ABF, 0xBFA80240}}, {{0xC229B627, 0x3C4941AF}}},
	{{{0x26214474, 0x3FF003C8}}, {{0x45DFB29B, 0xBC4AE17A}},
	  {{0xB526F7CF, 0xBFA601BB}}, {{0x2DA1796B, 0x3C39422F}}},
	{{{0x1A0B0179, 0x3FF00320}}, {{0xD21A4C9A, 0x3C9FA45B}},
	  {{0x5BD80F80, 0xBFA4014D}}, {{0xA4813A5B, 0xBC45A2E6}}},
	{{{0x11162E22, 0x3FF00288}}, {{0x2A930764, 0x3C6F0E22}},
	  {{0x03D82DD0, 0xBFA200F3}}, {{0x0CBDB96B, 0xBC4BE9EF}}},
	{{{0x0AAAC16C, 0x3FF00200}}, {{0x578DDD8D, 0x3C88618F}},
	  {{0xACCCD00D, 0xBFA000AA}}, {{0x1EFF67C8, 0xBBFD9E59}}},
	{{{0x0640B4E1, 0x3FF00188}}, {{0x8827C989, 0x3C7FB10F}},
	  {{0xACDAE8F4, 0xBF9C00E4}}, {{0x22A0BAC6, 0xBBE94741}}},
	{{{0x0360040D, 0x3FF00120}}, {{0x402EAB5F, 0xBC884C57}},
	  {{0x01033411, 0xBF980090}}, {{0xDD340191, 0xBC37E141}}},
	{{{0x01A0AC06, 0x3FF000C8}}, {{0x673A2EEE, 0xBC7BD6C4}},
	  {{0x55BD803E, 0xBF940053}}, {{0xCA73460D, 0xBBD1997B}}},
	{{{0x00AAAB06, 0x3FF00080}}, {{0x2ABAD90D, 0xBC93E2BE}},
	  {{0xAACCCCDA, 0xBF90002A}}, {{0x3AC1711C, 0x3C293021}}},
	{{{0x00360010, 0x3FF00048}}, {{0xDB8F0A40, 0x3C899AE6}},
	  {{0x00103337, 0xBF880024}}, {{0xAF88B300, 0x3C250734}}},
	{{{0x000AAAAC, 0x3FF00020}}, {{0x1862ADFD, 0x3C76C186}},
	  {{0xAAACCCCD, 0xBF80000A}}, {{0x9193923E, 0xBBBA01FC}}},
	{{{0x0000AAAB, 0x3FF00008}}, {{0x8D68D67B, 0xBC93E93E}},
	  {{0xAAAACCCD, 0xBF700002}}, {{0x17BFB4DB, 0x3C093193}}},
	{{{0x00000000, 0x3FF00000}}, {{0x00000000, 0x00000000}},
	  {{0x00000000, 0x00000000}}, {{0x00000000, 0x00000000}}},
	{{{0x0000AAAB, 0x3FF00008}}, {{0x8D68D67B, 0xBC93E93E}},
	  {{0xAAAACCCD, 0x3F700002}}, {{0x17BFB4DB, 0xBC093193}}},
	{{{0x000AAAAC, 0x3FF00020}}, {{0x1862ADFD, 0x3C76C186}},
	  {{0xAAACCCCD, 0x3F80000A}}, {{0x9193923E, 0x3BBA01FC}}},
	{{{0x00360010, 0x3FF00048}}, {{0xDB8F0A40, 0x3C899AE6}},
	  {{0x00103337, 0x3F880024}}, {{0xAF88B300, 0xBC250734}}},
	{{{0x00AAAB06, 0x3FF00080}}, {{0x2ABAD90D, 0xBC93E2BE}},
	  {{0xAACCCCDA, 0x3F90002A}}, {{0x3AC1711C, 0xBC293021}}},
	{{{0x01A0AC06, 0x3FF000C8}}, {{0x673A2EEE, 0xBC7BD6C4}},
	  {{0x55BD803E, 0x3F940053}}, {{0xCA73460D, 0x3BD1997B}}},
	{{{0x0360040D, 0x3FF00120}}, {{0x402EAB5F, 0xBC884C57}},
	  {{0x01033411, 0x3F980090}}, {{0xDD340191, 0x3C37E141}}},
	{{{0x0640B4E1, 0x3FF00188}}, {{0x8827C989, 0x3C7FB10F}},
	  {{0xACDAE8F4, 0x3F9C00E4}}, {{0x22A0BAC6, 0x3BE94741}}},
	{{{0x0AAAC16C, 0x3FF00200}}, {{0x578DDD8D, 0x3C88618F}},
	  {{0xACCCD00D, 0x3FA000AA}}, {{0x1EFF67C8, 0x3BFD9E59}}},
	{{{0x11162E22, 0x3FF00288}}, {{0x2A930764, 0x3C6F0E22}},
	  {{0x03D82DD0, 0x3FA200F3}}, {{0x0CBDB96B, 0x3C4BE9EF}}},
	{{{0x1A0B0179, 0x3FF00320}}, {{0xD21A4C9A, 0x3C9FA45B}},
	  {{0x5BD80F80, 0x3FA4014D}}, {{0xA4813A5B, 0x3C45A2E6}}},
	{{{0x26214474, 0x3FF003C8}}, {{0x45DFB29B, 0xBC4AE17A}},
	  {{0xB526F7CF, 0x3FA601BB}}, {{0x2DA1796B, 0xBC39422F}}},
	{{{0x36010336, 0x3FF00480}}, {{0x10BEB244, 0xBC89227D}},
	  {{0x10336ABF, 0x3FA80240}}, {{0xC229B627, 0xBC4941AF}}},
	{{{0x4A624DAE, 0x3FF00548}}, {{0x23E9C180, 0x3C5D0575}},
	  {{0x6D81EE12, 0x3FAA02DC}}, {{0x7E00BA39, 0xBC2A5E3B}}},
	{{{0x640D384F, 0x3FF00620}}, {{0x170FB049, 0xBC97FCBC}},
	  {{0xCDAF09CF, 0x3FAC0392}}, {{0x7D4F7337, 0xBC2B59CD}}},
	{{{0x83D9DCD5, 0x3FF00708}}, {{0x430DE399, 0xBC9EC747}},
	  {{0x317148DD, 0x3FAE0465}}, {{0x7929765A, 0xBC4B5DB1}}},
	{{{0xAAB05B20, 0x3FF00800}}, {{0x9FEBDB21, 0xBC936EB9}},
	  {{0xCCCD9CDD, 0x3FB002AA}}, {{0xFAC9C47C, 0xBC53A7FD}}},
	{{{0xD988DA1B, 0x3FF00908}}, {{0x94C96CA5, 0x3C9519B1}},
	  {{0x038EB7A7, 0x3FB10333}}, {{0x317BAEA7, 0xBC044B95}}},
	{{{0x116B88B6, 0x3FF00A21}}, {{0xAAAEC5A4, 0xBC71D458}},
	  {{0x3D8440EF, 0x3FB203CC}}, {{0x41B5A4E1, 0xBC1EF162}}},
	{{{0x53709EEA, 0x3FF00B49}}, {{0xF8CDACD0, 0xBC9DF4D4}},
	  {{0x7B47880C, 0x3FB30477}}, {{0x3B77E1B2, 0x3C517BE5}}},
	{{{0xA0C05ED4, 0x3FF00C81}}, {{0x7A57AC2E, 0xBC7736A7}},
	  {{0xBD83E026, 0x3FB40535}}, {{0x5F0B8AC5, 0xBC4B9B73}}},
	{{{0xFA9315DF, 0x3FF00DC9}}, {{0x602B4C56, 0xBC84D0E2}},
	  {{0x04F7A0DD, 0x3FB50608}}, {{0xEDAF37D2, 0x3C239FF7}}},
	{{{0x62311DF8, 0x3FF00F22}}, {{0xA7C410F3, 0x3C99322E}},
	  {{0x5275270D, 0x3FB606EF}}, {{0xE6EE4DC3, 0xBC56910E}}},
	{{{0xD8F2DEDB, 0x3FF0108A}}, {{0x53B40698, 0x3C93DC21}},
	  {{0xA6E3D59B, 0x3FB707EC}}, {{0xF456FFFF, 0xBC5030B2}}},
	{{{0x6040CF67, 0x3FF01203}}, {{0x422FB0BC, 0x3C9847C0}},
	  {{0x03411660, 0x3FB80901}}, {{0x10739476, 0x3C5DD342}}},
	{{{0xF993770A, 0x3FF0138B}}, {{0xB809A4D7, 0xBC7502E0}},
	  {{0x68A15B27, 0x3FB90A2D}}, {{0x7F556554, 0x3C5B1BE3}}},
	{{{0xA6736F36, 0x3FF01524}}, {{0xC450FC30, 0x3C930803}},
	  {{0xD8311EBE, 0x3FBA0B72}}, {{0x50193D71, 0x3C507AA8}}},
	{{{0x687964EF, 0x3FF016CD}}, {{0x209297AD, 0xBC9D38AB}},
	  {{0x5335E625, 0x3FBB0CD2}}, {{0xFBDC145A, 0x3C480157}}},
	{{{0x414E1A5C, 0x3FF01886}}, {{0xE0B191DA, 0x3C4976C5}},
	  {{0xDB0F41D4, 0x3FBC0E4C}}, {{0xC9BFC58B, 0xBC586525}}},
	{{{0x32AA6878, 0x3FF01A4F}}, {{0x67BCC8B5, 0x3C833FDA}},
	  {{0x7137CF18, 0x3FBD0FE3}}, {{0x698E234C, 0xBC4AE71D}}},
	{{{0x3E5740C5, 0x3FF01C28}}, {{0x9EC02117, 0x3C95D295}},
	  {{0x17463991, 0x3FBE1197}}, {{0x410E61A9, 0x3C5E1FCA}}},
	{{{0x662DAF18, 0x3FF01E11}}, {{0x3120653C, 0xBC833F82}},
	  {{0xCEEE3CC9, 0x3FBF1368}}, {{0x7BD924AB, 0xBC5213E7}}},
	{{{0xAC16DB6F, 0x3FF0200A}}, {{0x99576FC1, 0xBC809B4F}},
	  {{0xCD00D2F1, 0x3FC00AAC}}, {{0x146349DE, 0xBC53EA29}}},
	{{{0x120C0BDE, 0x3FF02214}}, {{0x6B72974E, 0xBC9456D2}},
	  {{0x3D38AAB7, 0x3FC08BB5}}, {{0xD37D3177, 0x3C60FB6D}}},
	{{{0x9A16A685, 0x3FF0242D}}, {{0x295277DB, 0xBC7352FD}},
	  {{0x392720B0, 0x3FC10CCE}}, {{0x1E4C8E28, 0x3C55A291}}},
	{{{0x4650339C, 0x3FF02657}}, {{0x0688DD52, 0xBC31EC5D}},
	  {{0x41E53B8C, 0x3FC18DF8}}, {{0x50E682BB, 0x3C49852D}}},
	{{{0x18E25F8B, 0x3FF02891}}, {{0x524ABA66, 0xBC9A7DA4}},
	  {{0xD89D0ECD, 0x3FC20F33}}, {{0x55A9198D, 0xBC6557F7}}},
	{{{0x1406FD12, 0x3FF02ADB}}, {{0x720D8336, 0x3C969329}},
	  {{0x7E8A3BEF, 0x3FC29081}}, {{0x8F21151D, 0xBC65A4E2}}},
	{{{0x3A080789, 0x3FF02D35}}, {{0xF6C7E6F8, 0xBC907780}},
	  {{0xB4FA73A6, 0x3FC311E1}}, {{0x4C87081D, 0xBC61065E}}},
	{{{0x8D3FA521, 0x3FF02F9F}}, {{0x88A18235, 0xBC58A44A}},
	  {{0xFD4DF72A, 0x3FC39354}}, {{0x64EC3B0C, 0x3C4EAAC2}}},
	{{{0x10182946, 0x3FF0321A}}, {{0xFE5F3FF1, 0x3C88FA5C}},
	  {{0xD8F81999, 0x3FC414DB}}, {{0x0B2260AC, 0xBC3E1438}}},
	{{{0xC50C1706, 0x3FF034A4}}, {{0x7ECC2F29, 0xBC8A9076}},
	  {{0xC97FC168, 0x3FC49676}}, {{0x93C07384, 0xBC6B5D13}}},
	{{{0xAEA6238A, 0x3FF0373F}}, {{0x72989A92, 0xBC73E9A1}},
	  {{0x507FE9EB, 0x3FC51826}}, {{0x6946DA28, 0xBC6AC219}}},
	{{{0xCF8138A4, 0x3FF039EA}}, {{0x8FE6098D, 0x3C8ACC0C}},
	  {{0xEFA824F1, 0x3FC599EA}}, {{0x2B9BA1A8, 0xBC5F28E7}}},
	{{{0x2A487769, 0x3FF03CA6}}, {{0xB95A2E63, 0xBC9585FD}},
	  {{0x28BD1C73, 0x3FC61BC5}}, {{0x2267ECEB, 0xBC625559}}},
	{{{0xC1B73AD9, 0x3FF03F71}}, {{0xA8202E85, 0xBC885168}},
	  {{0x7D991458, 0x3FC69DB5}}, {{0x97B08BD2, 0xBC69321C}}},
	{{{0x98991A9F, 0x3FF0424D}}, {{0xA130683D, 0x3C66BB23}},
	  {{0x702C6C4F, 0x3FC71FBC}}, {{0x00C832DD, 0x3C6BAA2A}}},
	{{{0xB1C9EDDA, 0x3FF04539}}, {{0xC7598281, 0x3C8D2224}},
	  {{0x827E21C3, 0x3FC7A1DA}}, {{0x06D46085, 0x3C6CB79F}}},
	{{{0x1035CDFA, 0x3FF04836}}, {{0xBBC5EC1C, 0xBC9E50AA}},
	  {{0x36AC51DD, 0x3FC82410}}, {{0xDF8CB355, 0x3C5A42DC}}},
	{{{0xB6D919A9, 0x3FF04B42}}, {{0x92AA0A0B, 0xBC9F2338}},
	  {{0x0EECBBA5, 0x3FC8A65E}}, {{0x0663DF15, 0xBC6339DB}}},
	{{{0xA8C077CC, 0x3FF04E5F}}, {{0xECF07BF2, 0xBC9D8190}},
	  {{0x8D8D4236, 0x3FC928C4}}, {{0x370EDF81, 0x3C556048}}},
	{{{0xE908DA8C, 0x3FF0518C}}, {{0x25A535E2, 0x3C987D18}},
	  {{0x34F46F10, 0x3FC9AB44}}, {{0x57573053, 0x3C1274BC}}},
	{{{0x7ADF8277, 0x3FF054CA}}, {{0x377A9F8C, 0x3C89C0C1}},
	  {{0x87A1F479, 0x3FCA2DDD}}, {{0xF07409B2, 0x3C67E5CE}}},
	{{{0x618201A8, 0x3FF05818}}, {{0x5A557953, 0xBC8BFA98}},
	  {{0x082F3002, 0x3FCAB091}}, {{0x60BF022C, 0xBC4B6626}}},
	{{{0xA03E3F07, 0x3FF05B76}}, {{0x2B52E765, 0x3C7CA615}},
	  {{0x394FAD1B, 0x3FCB335F}}, {{0x34B51ACE, 0x3C47F257}}},
	{{{0x3A727999, 0x3FF05EE5}}, {{0x6647668D, 0x3C92512F}},
	  {{0x9DD1A7CC, 0x3FCBB648}}, {{0x3ED3824D, 0xBC234425}}},
	{{{0x338D4BDC, 0x3FF06264}}, {{0xF34422A4, 0xBC90000F}},
	  {{0xB89E8F7F, 0x3FCC394D}}, {{0x52292D2D, 0x3C646F77}}},
	{{{0x8F0DAF34, 0x3FF065F3}}, {{0xAF1520A9, 0xBC7821B3}},
	  {{0x0CBB89ED, 0x3FCCBC6F}}, {{0x51092884, 0x3C4B40A0}}},
	{{{0x5082FF6E, 0x3FF06993}}, {{0xD7395A9F, 0x3C7685C4}},
	  {{0x1D49F620, 0x3FCD3FAD}}, {{0x26ECE4F0, 0xBC5DE851}}},
	{{{0x7B8CFE4D, 0x3FF06D43}}, {{0xD1025E7E, 0xBC73ADF7}},
	  {{0x6D87EF96, 0x3FCDC308}}, {{0x2A97B34C, 0xBC6C0BD9}}},
	{{{0x13DBD729, 0x3FF07104}}, {{0xCA5328ED, 0x3C766560}},
	  {{0x80D0D17F, 0x3FCE4681}}, {{0x658D0660, 0xBC605627}}},
	{{{0x1D3022A1, 0x3FF074D5}}, {{0x2426EF93, 0x3C9E93F8}},
	  {{0xDA9DBA19, 0x3FCECA18}}, {{0x491D8A98, 0xBC36D470}}},
	{{{0x9B5AEA5C, 0x3FF078B6}}, {{0x6B6D819B, 0xBC8880D6}},
	  {{0xFE860E28, 0x3FCF4DCE}}, {{0xC6A2C678, 0x3C6883D4}}},
	{{{0x923DACD6, 0x3FF07CA8}}, {{0xE736D67A, 0xBC9653A7}},
	  {{0x703FFC8F, 0x3FCFD1A4}}, {{0xA8860819, 0x3C59EA3B}}},
	{{{0x05CA6146, 0x3FF080AB}}, {{0xFC66378F, 0xBC723216}},
	  {{0xD9D08102, 0x3FD02ACC}}, {{0x20C03715, 0xBC5998B3}}},
	{{{0xFA037B8F, 0x3FF084BD}}, {{0xE3C5EBFC, 0xBC7D97E2}},
	  {{0xA64F3673, 0x3FD06CD7}}, {{0x839871E4, 0x3C6370BA}}},
	{{{0x72FBF041, 0x3FF088E1}}, {{0x0D55140F, 0xBC9DE12F}},
	  {{0xDFA6F09B, 0x3FD0AEF2}}, {{0xA7827088, 0xBC414E60}}},
	{{{0x74D738AC, 0x3FF08D15}}, {{0xC4A8C043, 0xBC984BD5}},
	  {{0xC7F2EE53, 0x3FD0F11E}}, {{0xC5355AFC, 0x3C75BADF}}},
	{{{0x03C95705, 0x3FF0915A}}, {{0x0BD1CD00, 0x3C78A8A6}},
	  {{0xA15F1D6C, 0x3FD1335B}}, {{0x341ED7B6, 0xBC53CE0F}}},
	{{{0x2416DA9A, 0x3FF095AF}}, {{0x39DC7749, 0x3C8024A0}},
	  {{0xAE285CD6, 0x3FD175A9}}, {{0xC4496E39, 0xBC3DB749}}},
	{{{0xDA14E415, 0x3FF09A14}}, {{0x233B29C8, 0xBC965668}},
	  {{0x309CBEE1, 0x3FD1B809}}, {{0xBBB1CB75, 0x3C6E5B16}}},
	{{{0x2A2929D1, 0x3FF09E8B}}, {{0x535446B4, 0xBC9EE5F5}},
	  {{0x6B1BCB8A, 0x3FD1FA7A}}, {{0x5A4CB636, 0x3C50621A}}},
	{{{0x18C9FC41, 0x3FF0A312}}, {{0x09E044C2, 0x3C885259}},
	  {{0xA016C2D9, 0x3FD23CFD}}, {{0x449D986B, 0xBC500762}}},
	{{{0xAA7E4A68, 0x3FF0A7A9}}, {{0x281520E0, 0x3C71B296}},
	  {{0x1210DF54, 0x3FD27F93}}, {{0x502A1E59, 0xBC6EF999}}},
	{{{0xE3DDA65B, 0x3FF0AC51}}, {{0x9DACA977, 0x3C9B22C0}},
	  {{0x039F9881, 0x3FD2C23B}}, {{0x9B082732, 0x3C577301}}},
	{{{0xC99049DE, 0x3FF0B10A}}, {{0x610FCC2E, 0xBC617C2D}},
	  {{0xB76AE57E, 0x3FD304F5}}, {{0x42E4CA9C, 0xBC75EB09}}},
	{{{0x604F1B07, 0x3FF0B5D4}}, {{0x07EECFA5, 0x3C732C14}},
	  {{0x702D7FA4, 0x3FD347C3}}, {{0x701422C8, 0x3C7435BE}}},
	{{{0xACE3B0FC, 0x3FF0BAAE}}, {{0x75521E77, 0xBC93292F}},
	  {{0x70B52549, 0x3FD38AA4}}, {{0x0B01B8A6, 0xBC67F94B}}},
	{{{0xB42858B8, 0x3FF0BF99}}, {{0x0B1F30A5, 0xBC67AD83}},
	  {{0xFBE2DC86, 0x3FD3CD98}}, {{0x269038FC, 0xBC7D0A5E}}},
	{{{0x7B0819E9, 0x3FF0C495}}, {{0x6E52BA24, 0x3C9A26E0}},
	  {{0x54AB361D, 0x3FD410A1}}, {{0xCF7DA2E8, 0xBC78DCB6}}},
	{{{0x067EBBDA, 0x3FF0C9A2}}, {{0x803D61F3, 0x3C813CD8}},
	  {{0xBE16906C, 0x3FD453BD}}, {{0x45D8536E, 0x3C78D781}}},
	{{{0x5B98CA6C, 0x3FF0CEBF}}, {{0x09B9F220, 0x3C9E8080}},
	  {{0x7B415A78, 0x3FD496EE}}, {{0xBDFE61F1, 0xBC51C3BA}}},
	{{{0x7F739B28, 0x3FF0D3ED}}, {{0xEA8A9ED5, 0xBC99722F}},
	  {{0xCF5C5703, 0x3FD4DA33}}, {{0x7BE71FBE, 0x3C7B1F07}}},
	{{{0x773D5255, 0x3FF0D92C}}, {{0x3D5D1DA2, 0xBC84956C}},
	  {{0xFDACDFC5, 0x3FD51D8D}}, {{0x98966B86, 0xBC419F0E}}},
	{{{0x4834E82E, 0x3FF0DE7C}}, {{0x5F430E44, 0xBC877BEC}},
	  {{0x498D28AA, 0x3FD560FD}}, {{0xCCEA8A26, 0xBC4F07B3}}},
	{{{0xF7AA2E1B, 0x3FF0E3DC}}, {{0xF7FB3140, 0x3C9C05BD}},
	  {{0xF66C8331, 0x3FD5A481}}, {{0xCFF78DD1, 0x3C6E8E0C}}},
	{{{0x8AFDD406, 0x3FF0E94E}}, {{0xB0B14F49, 0xBC9330CB}},
	  {{0x47CFA1DB, 0x3FD5E81C}}, {{0x4E7B2C63, 0xBC791EC5}}},
	{{{0x07A16DB4, 0x3FF0EED1}}, {{0xD3E071F5, 0x3C988108}},
	  {{0x8150DBAB, 0x3FD62BCC}}, {{0xF95D00CA, 0x3C7700BD}}},
	{{{0x73177841, 0x3FF0F464}}, {{0x29551C51, 0xBC97DF60}},
	  {{0xE6A06FC9, 0x3FD66F92}}, {{0xD9A66B42, 0xBC70A785}}},
	{{{0xD2F35F97, 0x3FF0FA08}}, {{0x9DAB3AF1, 0x3C9B39D1}},
	  {{0xBB84C928, 0x3FD6B36F}}, {{0xFEFE1E5F, 0x3C68DAF8}}},
}; 
/* the coefficients for the cosh-approximations */ 
  static const db_number c0 =   {{0x00000000,0x3FF00000}};     /*1.0000000000e+00*/  
  static const db_number c2 =   {{0x00000000,0x3FE00000}};     /*5.0000000000e-01*/  
  static const db_number c4 =   {{0x55555555,0x3FA55555}};     /*4.1666666667e-02*/  
  static const db_number c6 =   {{0x16C16C17,0x3F56C16C}};     /*1.3888888889e-03*/  
  static const db_number c8 =   {{0x1A01A01A,0x3EFA01A0}};     /*2.4801587302e-05*/  
/* the coefficients for the sinh-approximations */
  static  const db_number s1 =   {{0x00000000,0x3FF00000}};     /*1.0000000000e+00*/  
  static  const db_number s3 =   {{0x55555555,0x3FC55555}};     /*1.6666666667e-01*/  
  static  const db_number s5 =   {{0x11111111,0x3F811111}};     /*8.3333333333e-03*/  
  static  const db_number s7 =   {{0x1A01A01A,0x3F2A01A0}};     /*1.9841269841e-04*/  
#endif  
